<a href="https://super-productivity.com/">
  <img align="center" alt="Banner" src="screens/banner-bw.png" />
</a>

<p align="center" style="text-align: center;">
<a href="https://lbesson.mit-license.org">
  <img alt="MIT license"
       src="https://img.shields.io/badge/License-MIT-blue.svg?style=flat-square"
       align="center">
</a>
<a href="https://github.com/johannesjo/super-productivity/releases">
  <img alt="GitHub All Releases"
       src="https://img.shields.io/github/downloads/johannesjo/super-productivity/total"
       align="center">
</a>
<a href="https://www.producthunt.com/posts/super-productivity">
  <img alt="On product hunt"
       src="https://img.shields.io/badge/on-product%20hunt-blue.svg?style=flat-square"
       align="center">
</a>
<a href="https://twitter.com/intent/tweet?text=Super%20Productivity%20%20https%3A%2F%2Fsuper-productivity.com">
  <img alt="tweet"
       src="https://img.shields.io/twitter/url/https/github.com/ArmynC/ArminC-AutoExec.svg?style=flat-square&logo=twitter"
       target="_blank"
       align="center" />
</a>

<br>
<br>

<a href="https://snapcraft.io/superproductivity"        target="_blank">
  <img alt="Get it from the Snap Store"
       src="https://snapcraft.io/static/images/badges/en/snap-store-black.svg"
       align="center"
       height="50">
</a>
<a href='//www.microsoft.com/store/apps/9NHFVG8361TW?cid=storebadge&ocid=badge' target="_blank">
  <img src='https://developer.microsoft.com/store/badges/images/English_get-it-from-MS.png'
       align="center"
       alt='English badge'
       height="50" />
</a>
<a href='//apps.apple.com/de/app/super-productivity/id1482572463?l=en&mt=12' target="_blank">
  <img src='./screens/app-store-badge.svg'
       align="center"
       alt='App Store Badge'
       height="50" />
</a>
<a href='//play.google.com/store/apps/details?id=com.superproductivity.superproductivity' target="_blank">
  <img src='./screens/google-play-badge.png'
       align="center"
       alt='Play Store Badge'
       height="50" />
</a>

Organize your daily tasks in one place while making time tracking a lot less annoying. Super Productivity is a ToDo List / Time Tracker / Personal Jira Task Manager for Linux, MacOS and Windows aimed at reducing the time you spend with repetitive tasks and to provide you with a place to collect all the information you need to do your job.

<p align="center"><a href="http://super-productivity.com">:globe_with_meridians: Open Web App</a> or <a href="https://github.com/johannesjo/super-productivity/releases">:computer: Download</a></p>

## :heavy_check_mark: Features

- **Plan, track & summarize**. Create time sheets and work summaries in a breeze to easily export them to your company's time tracking system.
- Integrate with **Jira**, **GitHub**, **GitLab** and **OpenProject**. Auto import tasks assigned to you, plan the details locally, automatically create worklogs and get notified right away, when something changes.
- Organize your project's data. Create **notes**, attach **files** or create **bookmarks** for links, files and even commands and have it all out of the way, once you're ready for the weekend.
- Helps you to **establish healthy habits**. A break timer reminds to you, when it's time to step away. You also can collect personal metrics for yourself to see, which of your work routines need adjustments.
- Stuck and procrastinating? No problem! Super Productivity's **anti procrastination** feature helps you to reconsider your options and a **pomodoro timer** is also always at hand.
- Super Productivity **does NOT collect any data** and there are no user accounts or registration. It's **free** and **open source** and always will be.

And much more!

<a href="https://youtu.be/_mvMXWLsL-8"><img alt="Work View with global links" src="screens/screen_standard.png" width="100%"></a>

## :question: How to use it

I wrote [a little article](https://dev.to/johannesjo/super-productivity-how-to-grow-fond-of-time-tracking-and-task-management-22ee) on how I use the app - and [another one](https://dev.to/johannesjo/the-prioritising-scheme-how-to-eat-the-frog-with-super-productivity-mlk) on how I implement the 'eat the frog' prioritizing scheme in the app . There is also [a youtube video available](https://www.youtube.com/watch?v=VoF2_RSdNXA).

## :globe_with_meridians: Web Version

Check out the web version eventhough it is a bit limited: Time tracking only works if the app is open and for idle time tracking to work, the chrome extension has to be installed.

If you want the Jira integration and idle time tracking to work, you have to also download and install the [Super Productivity Chrome Extension](https://chrome.google.com/webstore/detail/super-productivity/ljkbjodfmekklcoibdnhahlaalhihmlb).

## :computer: Downloads & Install

### All Platforms

[Install from the releases page](https://github.com/johannesjo/super-productivity/releases).

### Windows

Due to certification issues it's recommended to download the app from the Microsoft Store:

<a href='//www.microsoft.com/store/apps/9nhfvg8361tw?cid=storebadge&ocid=badge'><img src='https://developer.microsoft.com/store/badges/images/English_get-it-from-MS.png' alt='English badge' width="127" height="52"/></a>

### Linux

```
# stable
sudo snap install superproductivity

# edge channel releases
 sudo snap install --channel=edge superproductivity
```

<a href="https://snapcraft.io/superproductivity">
  <img alt="Get it from the Snap Store" src="https://snapcraft.io/static/images/badges/en/snap-store-black.svg" />
</a>

#### Arch

```bash
git clone https://aur.archlinux.org/superproductivity-bin.git
cd superproductivity-bin
makepkg -si
```

### MacOS

Install via [homebrew cask](https://github.com/caskroom/homebrew-cask):

```
brew install --cask superproductivity
```

<a href='//apps.apple.com/de/app/super-productivity/id1482572463?l=en&mt=12' target="_blank">
  <img src='./screens/app-store-badge.svg'
       alt='App Store Badge'
       height="50" />
</a>

### Android

There is a [very early(!) Android version available](https://play.google.com/store/apps/details?id=com.superproductivity.superproductivity&hl=gsw). The sources can be [found here](https://github.com/johannesjo/super-productivity-android).

<a href='//play.google.com/store/apps/details?id=com.superproductivity.superproductivity' target="_blank">
  <img src='./screens/google-play-badge.png'
       align="center"
       alt='App Store Badge'
       height="50" />
</a>

## :hearts: Contributing

Please check out the [CONTRIBUTING.md](CONTRIBUTING.md)

There are several ways to help.

1. **Spread the word:** More users means more people testing and contributing to the app which in turn means better stability and possibly more and better features. You can vote for Super Productivity on [Slant](https://www.slant.co/topics/14021/viewpoints/7/~productivity-tools-for-linux~super-productivity), [Product Hunt](https://www.producthunt.com/posts/super-productivity), [Softpedia](https://www.softpedia.com/get/Office-tools/Diary-Organizers-Calendar/Super-Productivity.shtml) or on [AlternativeTo](https://alternativeto.net/software/super-productivity/), you can [tweet about it](https://twitter.com/intent/tweet?text=I%20like%20Super%20Productivity%20%20https%3A%2F%2Fsuper-productivity.com), share it on [LinkedIn](http://www.linkedin.com/shareArticle?mini=true&url=https://super-productivity.com&title=I%20like%20Super%20Productivity&), [reddit](http://www.reddit.com/submit?url=https%3A%2F%2Fsuper-productivity.com&title=I%20like%20Super%20Productivity) or any of your favorite social media platforms. Every little bit helps!

2. **[Make a feature or improvement request](https://github.com/johannesjo/super-productivity/issues/new)**: Something can be be done better? Something essential missing? Let us know!

3. **[Report bugs](https://github.com/johannesjo/super-productivity/issues/new)**

4. **Contribute**: You don't have to be programmer to help. Some of the icons really need improvement and many of the [translations could use some love](https://github.com/johannesjo/super-productivity/discussions/1493).

5. **[Sponsor the project](https://github.com/sponsors/johannesjo)**

### Pull Requests

**Pull requests** are of course very welcome! Please make sure that you're following the [angular commit guidelines](https://github.com/angular/angular.js/blob/master/DEVELOPERS.md#commits) and to also include the issue number in your commit message, if you're fixing a particular issue (e.g.: `feat: add nice feature with the number #31`).

### Running the development server

To run the development server you need to have node installed at least in the version 14. Go to https://nodejs.org for installation instructions.

**Clone repo**

```
git clone https://github.com/johannesjo/super-productivity.git
```

**Install dependencies**

```
cd super-productivity
npm i -g @angular/cli
npm i
```

**Run the dev server**

```
ng serve
```

Afterwards you can open http://localhost:4200 in your browser. For most adjustments this should be enough and also enables you to use the [redux dev tools](https://chrome.google.com/webstore/detail/redux-devtools/lmhkpmbekcpmknklioeibfkpmmfibljd?hl=de).

If you want to run the app standalone do the following:

```
ng serve

# in a new console tab
npm start
```

### Packaging the app

Packaging the app is done via [electron-builder](https://github.com/electron-userland/electron-builder). To start packaging run `npm run dist`. If you want to add new platforms and experiment with the build options the easiest way to do so is manipulating the `build` property in the [package.json](https://github.com/johannesjo/super-productivity/blob/develop/package.json), but you can also use the [command line interface of electron builder](https://www.electron.build/cli).

## Run as Docker Container

```
docker run -d -p 80:80 johannesjo/super-productivity:latest
```

## Custom themes (desktop only)

In addition to color coding your projects and tags and to the dark and light theme you can also load completely custom css to restyle everything. To load a custom theme you simply need put them into a new file named `styles.css` directly in the [user data folder](#user-data-folder).

There is a great set of [themes available for download in this repository](https://github.com/johannesjo/super-productivity-themes/tree/main/dist) as well as some [info on how to role out your own custom themes](https://github.com/johannesjo/super-productivity-themes).

## Custom WebDAV Syncing

If using the integrated WebDAV Syncing is not working out for you, you can also try to sync all app files, which are located in the [user data folder](#user-data-folder).

## Automatic Backups

For the desktop version automatic backups are stored per default in the `backup` sub folder of the [user data folder](#user-data-folder). Once you located a backup you can restore it on the settings page under `Sync & Export/Import/Export/Import from file`.

## User Data Folder

Where user data is stored differs from os to os. The most common locations are:
Mac OS: `~/Library/Application Support/superProductivity/`
Windows: `C:\Users\<YOUR_USER_NAME>\AppData\Roaming\superProductivity/` or `%APPDATA%\superProductivity`
Linux: `~/.config/superProductivity/`

The path should be shown when you go to the "Automatic Backups` section on the configuration page (minus the "backup" sub folder). You can also see it printed out when you start the app from the command line.

For web browsers data is simply stored for the current user inside the browser storage.

### Using a custom folder to save user data

You can specify a custom folder for saving your data by starting the application with the `--user-data-dir` parameter like so:

```
superproductivity --user-data-dir=/path/to/my/data
```
